<?php

if ( ! defined( 'ABSPATH' ) or ! is_admin() )
    exit;

class In_Class_PandaSMS_Ayarlar{

    function __construct()
    {

        /**
         * Uygulama Menü
         */
        add_action( 'admin_menu', array( $this, 'menu' ) );

        add_action( 'admin_enqueue_scripts', array( $this, 'pandasms_js_dosyalari' ) );

        add_action( 'admin_init', array( $this, 'kayit_pandasms_msg_ayarlar' ) );

        add_action( 'admin_init', array( $this, 'register_pandasms_abonelik_ayarlar' ) );

        add_action( 'wp_ajax_pandasms_manuel_kargo_bildirimi_gonder', array( $this, 'callback_pandasms_manuel_kargo_bildirimi_gonder' ) );

        /**
         * Manuel Kargo Bildirimi Buton Ekle
         */

        add_filter( 'woocommerce_admin_order_actions', array( $this, 'manuel_kargo_bildirimi_gonder'), 100, 2);

        add_action( 'admin_head', array( $this, 'manuel_kargo_bildirimi_gonder_style') );

    }





    function menu() {

        add_menu_page('PandaSMS', 'PandaSMS', 'administrator', 'pandasms_msg_ayarlar', array( $this, 'pandasms_msg_ayarlar') , '');
        add_submenu_page('pandasms_msg_ayarlar', 'Mesaj Ayarları', 'Mesaj Ayarları', 'administrator', 'pandasms_msg_ayarlar', array( $this, 'pandasms_msg_ayarlar') );
        add_submenu_page('pandasms_msg_ayarlar', 'Abone Bilgileri', 'Abone Bilgileri', 'administrator', 'pandasms_abonelik_ayarlar', array( $this, 'pandasms_abonelik_ayarlar') );

    }



    function pandasms_js_dosyalari($hook){

        if ( 'post.php' != $hook )
            return;

        wp_enqueue_script( 'pandasms', PANDASMS_UYGULAMA_URL.'js/widget.js?time='.time(), array('jquery') );

        wp_localize_script( 'pandasms', 'ajax_var', array(

            'url' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('pandasms-rapor-sorgula-nonce')

        ));

    }



    /**
     * Uygulama Mesaj Ayarları
     */

    function kayit_pandasms_msg_ayarlar() {

        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_newOrder_msg' );
        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_newOrder_status' );

        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_shipped_msg' );
        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_shipped_status' );

        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_kurye_teslim_msg' );
        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_kurye_teslim_durum' );

        register_setting( 'pandasms-msg-settings', 'pandasms_customerAlert_send_shipping_url_status' );

        register_setting( 'pandasms-msg-settings', 'pandasms_adminAlert_newOrder_msg' );
        register_setting( 'pandasms-msg-settings', 'pandasms_adminAlert_newOrder_status' );
        register_setting( 'pandasms-msg-settings', 'admin_gsm' );
        register_setting( 'pandasms-msg-settings', '_pandasms_entegre_intense_modul' );
    }

    /**
     * Mesaj Ayayları Views
     */
    function pandasms_msg_ayarlar()
    {
        ?>
        <div class="wrap">
            <h1>Bildirim Metinleri</h1>

            <form method="post" action="options.php">
                <?php settings_fields( 'pandasms-msg-settings' ); ?>
                <?php do_settings_sections( 'pandasms-msg-settings' ); ?>

                <h2>Ayarlar</h2>
                <table style="width:80%" class="form-table">
                    <tr valign="top">
                        <th width="50%" scope="row">Yönetici GSM:</th>
                        <td width="10%">
                            <input type="text" name="admin_gsm" value="<?php echo esc_attr( get_option('admin_gsm') ); ?>" />
                        </td>
                        <td width="40%">Yönetici bildirimlerinin gönderileceği numarayı yazınız.</td>
                    </tr>
                    <tr valign="top">
                        <th width="50%" scope="row">Entegre Modül Seçiniz:</th>
                        <td width="10%">
                            <select name="_pandasms_entegre_intense_modul">
                                <option <?php if(esc_attr( get_option('_pandasms_entegre_intense_modul') )=="intense-manuel-kargo-takip") echo "selected "; ?>value="intense-manuel-kargo-takip">Intense Kargo Takip Uygulaması (Manuel)</option>
                                <option <?php if(esc_attr( get_option('_pandasms_entegre_intense_modul') )=="intense-entegrasyon-kargo-takip") echo "selected "; ?>value="intense-entegrasyon-kargo-takip">Intense Yurtiçi, MNG, Aras Tam Entegrasyonları</option>
                            </select>
                        </td>
                        <td width="40%">Yönetici bildirimlerinin gönderileceği numarayı yazınız.</td>
                    </tr>
                </table>

                <hr>
                <h2>Müşteri Mesajları</h2>
                <table style="width:80%" class="form-table">
                    <tr>
                        <th></th>
                        <th>Bildirim Metni</th>
                        <th>Aktif</th>
                        <th>Açıklama</th>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Sipariş Bildirimi:</th>
                        <td width="50%">
                            <textarea rows="3" style="width:100%" name="pandasms_customerAlert_newOrder_msg"><?php echo esc_attr( get_option('pandasms_customerAlert_newOrder_msg') ); ?></textarea>
                        </td>
                        <td><input type="checkbox" name="pandasms_customerAlert_newOrder_status" value="1" <?php if(esc_attr( get_option('pandasms_customerAlert_newOrder_status') )==1) echo "checked"; ?>/></td>
                        <td>Müşteriye sipariş verdiğinde gönderilir.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Sipariş Kargoya Verildiğinde:</th>
                        <td width="50%">
                            <textarea rows="3" style="width:100%" name="pandasms_customerAlert_shipped_msg"><?php echo esc_attr( get_option('pandasms_customerAlert_shipped_msg') ); ?></textarea>
                            Kargo bilgilerini mesajda göndermek için "<strong>{KargoBilgileri}</strong>" sipariş numarasını mesajda göstermek için {siparisNo} ifadesini mesaj alanına kopyalayın.
                        </td>
                        <td><input type="checkbox" name="pandasms_customerAlert_shipped_status" value="1" <?php if(esc_attr( get_option('pandasms_customerAlert_shipped_status') )==1) echo "checked"; ?>/></td>
                        <td width="30%">Sipariş durumu "Kargoya Verildi" yapıldığında müşteriye gönderilir. * Bu özellik Intense Kargo Modülü ile birlikte çalışır. Sipariş numarasını mesajda göstermek için {siparisNo} ifadesini mesaj alanına kopyalayınız.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Sipariş Kuryeye Verildiğinde:</th>
                        <td width="50%">
                            <textarea rows="3" style="width:100%" name="pandasms_customerAlert_kurye_teslim_msg"><?php echo esc_attr( get_option('pandasms_customerAlert_kurye_teslim_msg') ); ?></textarea>
                        </td>
                        <td><input type="checkbox" name="pandasms_customerAlert_kurye_teslim_durum" value="1" <?php if(esc_attr( get_option('pandasms_customerAlert_kurye_teslim_durum') )==1) echo "checked"; ?>/></td>
                        <td width="30%">Sipariş numarasını mesajda göstermek için {siparisNo} ifadesini mesaj alanına kopyalayınız.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Kargo Takip Link Durumu:</th>
                        <td width="50%">
                            Aktifleştirildiğinde kargo takip için gönderilen SMS'de kargo takip linki yer alır.
                        </td>
                        <td><input type="checkbox" name="pandasms_customerAlert_send_shipping_url_status" value="1" <?php if(esc_attr( get_option('pandasms_customerAlert_send_shipping_url_status') )==1) echo "checked"; ?>/></td>
                        <td width="30%">Bu özellik aktifleştirildğinde mesajlar gecikmeli gidebilir. (Güvenlik sebebiyle link içeren SMS'ler manuel onaylanmaktadır.)</td>
                    </tr>
                </table>

                <hr>
                <h2>Yönetici Mesajları</h2>
                <table style="width:80%" class="form-table">
                    <tr>
                        <th></th>
                        <th>Bildirim Metni</th>
                        <th>Aktif</th>
                        <th>Açıklama</th>
                    </tr>
                    <tr valign="top">
                        <th scope="row">Sipariş Bildirimi:</th>
                        <td width="50%">
                            <textarea rows="3" style="width:100%" name="pandasms_adminAlert_newOrder_msg"><?php echo esc_attr( get_option('pandasms_adminAlert_newOrder_msg') ); ?></textarea>
                        </td>
                        <td><input type="checkbox" name="pandasms_adminAlert_newOrder_status" value="1" <?php if(esc_attr( get_option('pandasms_adminAlert_newOrder_status') )==1) echo "checked"; ?>/></td>
                        <td width="30%">Sistem yöneticisine sipariş geldiğinde bildirim yapar.</td>
                    </tr>
                </table>

                <?php submit_button(); ?>

            </form>
        </div>
        <?php
    }

    /**
     * Abonelik Ayarları
     */
    function register_pandasms_abonelik_ayarlar() {

        register_setting( 'pandasms-user-settings', 'pandasms_username' );
        register_setting( 'pandasms-user-settings', 'pandasms_password' );
        register_setting( 'pandasms-user-settings', 'pandasms_apikey' );
        register_setting( 'pandasms-user-settings', 'pandasms_originator' );
    }


    /**
     * Abonelik Ayarları, Views
     */
    function pandasms_abonelik_ayarlar()
    {
        ?>
        <div class="wrap">
            <h1>PandaSMS Abonelik Bilgileriniz</h1>

            <form method="post" action="options.php">
                <?php settings_fields( 'pandasms-user-settings' ); ?>
                <?php do_settings_sections( 'pandasms-user-settings' ); ?>
                <table style="width:80%" class="form-table">
                    <tr valign="top">
                        <th width="30%" scope="row">PandaSMS Kullanıcı Adınız:</th>
                        <td width="70%"><input style="width:40%" type="text" name="pandasms_username" value="<?php echo esc_attr( get_option('pandasms_username') ); ?>" /></td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">PandaSMS Şifreniz:</th>
                        <td><input style="width:40%" type="password" name="pandasms_password" value="<?php echo esc_attr( get_option('pandasms_password') ); ?>" /></td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">PandaSMS API KEY:</th>
                        <td><input style="width:40%" type="text" name="pandasms_apikey" value="<?php echo esc_attr( get_option('pandasms_apikey') ); ?>" /></td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">PandaSMS Originator (Gönderim Başlığı):</th>
                        <td><input style="width:40%" type="text" name="pandasms_originator" value="<?php echo esc_attr( get_option('pandasms_originator') ); ?>" /></td>
                    </tr>
                </table>

                <?php submit_button(); ?>

            </form>
        </div>

        <?php
    }


    /**
     * Manuel SMS Buton Stilleri
     */

    function manuel_kargo_bildirimi_gonder_style(){

        $action_slug = "manuel_kargo_sms";

        echo '<style>.wc-action-button-'.$action_slug.'::after { font-family: woocommerce !important; content: "\e02d" !important; }</style>';

    }


    /**
     * Manuel SMS Gönderim İşlemi
     */

    function callback_pandasms_manuel_kargo_bildirimi_gonder(){

        global $wpdb;

        $nonce = $_REQUEST['_wpnonce'];

        $order_id = sanitize_text_field( $_GET['order_id'] );

        if ( ! wp_verify_nonce( $nonce, 'pandasms_manuel_kargo_sms' ) ) {

            /** Yetkisiz erişim */
            die( '' );

        } else {

            if($order_id>0){

                $bildirimler = new Bildirimler();

                /** bildirim yap */
                $bildirimler->kargoyaVerildiBildirimi($order_id);

                /** Eski sayfaya yönlendir. */
                wp_redirect(wp_get_referer());

                exit;

            }
        }


    }



    function manuel_kargo_bildirimi_gonder( $actions, $order ){

        if( $order->has_status( array( 'kargoya-verildi' ) ) ){

            $act_slug = 'manuel_kargo_sms';

            $order_id = method_exists( $order, 'get_id' ) ? $order->get_id() : $order->id;

            $actions[$act_slug] = array(
                'url'=>wp_nonce_url( admin_url('admin-ajax.php?action=pandasms_manuel_kargo_bildirimi_gonder&order_id='.$order_id), 'pandasms_manuel_kargo_sms' ),
                'name'=>'SMS ile kargo bilgilendirmesi yap.',
                'action'=>$act_slug
            );

        }

        return $actions;
    }


}

new In_Class_PandaSMS_Ayarlar();